
data x;
input v1 :$1. v2 v3 :$1. v4;
datalines;
a 1 x 77
b 2 y 88
c 3 z 99
;

proc summary data=x nway completetypes;
class v1 v2 v3;
var v4;
output out=y (drop=_:) sum=;
run;

proc print data=y;
run;

* if you want to ... replace missing values of V4 with zeroes;
proc stdize data=y out=y reponly missing=0;
var v4;
run;

proc print data=y;
run;



proc sql;
create view temp as select a.v1, b.v2, c.v3 from x as a, x as b, x as c;
create table y   as select a.*, x.v4
from temp a left join x on catx('-',a.v1,a.v2,a.v3) = catx('-',x.v1,x.v2,x.v3);
quit;

proc print data=y;
run;
